#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "func.h"


/*----------------------------------------------------------------------*/
FILE *LeerNomFic(char *modo) {
	FILE *pfic;	/*Puntero al fichero*/

	char s[MAXENT];	/*Almacenar el nombre del fichero*/
	printf("\n\tNombre del fichero: ");
	gets(s);

	if ((pfic=fopen(s,modo))==NULL)
		printf("\n\tError en LeerNomFic: abriendo %s\n\n",s);

	return pfic;
}

/*----------------------------------------------------------------------*/

int *DatoArchivo(FILE *pfic){

    char aster;
    int numlin=0, numcar=0;
    int *pAster;
    pAster=(int *)malloc(MAXAST*sizeof(int));
    *pAster=NULL;

    while ((fscanf(pfic,"%c",&aster)!=EOF)&&(numlin<MAXFILAS)){
          if (numcar<MAXCOLUM){
             if (aster!='\n'){
                numcar++;
                if (aster=='*'){
                   guardar(pAster,MAXCOLUM*numlin+numcar);
                }
             }
             else {           /* linea termina antes */
                  numcar=0;
                  numlin++;
             }
          }
          else if (aster=='\n'){    /* ignora otros caracteres */
             numcar=0;
             numlin++;
          }
    }
    return pAster;
}

/*----------------------------------------------------------------------*/

int AnaDatos (int *pAster){

    int numero,numant=0,cerrada,bifurc,*pFig,*pBifurc;
    char *forma;

    pFig=(int *)malloc(MAXAST*sizeof(int));
    pBifurc=(int *)malloc(MAXAST*sizeof(int));

    *pFig=NULL;
    *pBifurc=NULL;

    if ((numero=pAster[0])!=0){    /* para el 1er asterisco encontrado */
       guardar(pFig,numero);      /* lo reconoce como de la figura */
       BuscaFigura(&numero,&numant,pFig,pBifurc,pAster);
    }

    cerrada=FigCerrada(pFig);
    bifurc=FigBifurc(pBifurc);
    forma=DetectaFigura(bifurc,cerrada);

    ImpResult(forma);

    printf("\n\tGracias por confiar en Software Ibez & Granda.\n\n");

    free(forma);
    free(pFig);
    free(pBifurc);

    return 0;
}

/*----------------------------------------------------------------------*/

int BuscaFigura (int *pnumero,int *pnumant,int *pFig,int *pBifurc,int *pAster){
    int *pNumAlred;
    
    while (1){
          pNumAlred = alrededor(*pnumant,*pnumero,pAster);
          if (!existen(pNumAlred,pFig)){  /* si estan en la figura */
             if (pNumAlred[1]){           /* si hay 2 '*' alrededor */
                if (pNumAlred[0]>*pnumero){  /* viene de un menor */
                   guardar(pBifurc,pNumAlred[0]);
                   *pnumant=*pnumero;
                   *pnumero=pNumAlred[1];
                }
                else {               /* viene de un mayor */
                     guardar(pBifurc,pNumAlred[1]);
                     *pnumant=*pnumero;
                     *pnumero=pNumAlred[0];
                }
             }
             else {                  /* slo hay 1 alrededor */
                  *pnumant=*pnumero;
                  *pnumero=pNumAlred[0];
             }
          }
          else {                /* no ha encontrado ninguno nuevo */
               break;
          }
          guardar(pFig,*pnumero);   /* guarda el nmero encontrado */
    }
    free (pNumAlred);
    return 0;
}


/*----------------------------------------------------------------------*/

int *alrededor (int numant,int numero,int* pAster){
    int mayor,hayuno=0,*pNumAlred;
    pNumAlred=(int *)malloc(2*sizeof(int));

    pNumAlred[0]=0;
    pNumAlred[1]=0;

    miralinea (numero,-MAXCOLUM,numant,&hayuno,pNumAlred,pAster);
    miralinea (numero,0,numant,&hayuno,pNumAlred,pAster);
    miralinea (numero,MAXCOLUM,numant,&hayuno,pNumAlred,pAster);

    if (pNumAlred[1]!=0){              /* ordena de menor a mayor */
       if (pNumAlred[1]<pNumAlred[0]){
          mayor=pNumAlred[0];
          pNumAlred[0]=pNumAlred[1];
          pNumAlred[1]=mayor;
       }
    }
    return pNumAlred;
}

/*----------------------------------------------------------------------*/

int miralinea(int numero,int pos,int numant,int *phayuno,int *pNumAlred,int *pAster){

/* le falta la chorrada de que no busque en las 8 de alrededor si
esta en la primera y ultima columna, y en la primera y ultima fila */   

    int i;

    for (i=(numero+pos-1);i<=(numero+pos+1);i++){
        if ((i!=numant)&&(i!=numero)&&(i>=*pAster))
           buscauno(i,pAster,phayuno,pNumAlred);
    }
    
    return 0;
}

/*----------------------------------------------------------------------*/

int existen(int *pNumAlred,int* pFigura){

    int exito,i;
    exito=0;

    for (i=0;i<2;i++){
        existeuno(pNumAlred[i],pFigura,&exito);    
    }
    return exito;
}

/*----------------------------------------------------------------------*/

int existeuno(int numero,int *pFigura,int *pexito){

    int primero;
    primero=*pFigura;
    while (*pFigura){
          if ((numero==*pFigura)&&(numero!=primero))
             *pexito=1;
          pFigura++;
    }
    return 0;
}

/*----------------------------------------------------------------------*/

int guardar(int *pPuntero,int dato){
  
  while (*pPuntero){   /* lo deja apuntando al ultimo elemento=0 */
        pPuntero++;
  }
  *pPuntero++=dato;
  *pPuntero=NULL;   /* deja un 0 siempre al final */
  
  return 0;
}

/*----------------------------------------------------------------------*/

int buscauno (int i,int *pAster,int *phayuno,int *pNumAlred){

    while ((*pAster)&&(*pAster<=i)){
          if (i==*pAster){
             if (!*phayuno){
                pNumAlred[0]=i;
                *phayuno=1;
             }
             else
                  pNumAlred[1]=i;
          }
    pAster++;
    }
    return 0;
}

/*----------------------------------------------------------------------*/

int FigCerrada (int *pFigura){

    int primero,cerrada=0;
    primero=*pFigura;

    while (*pFigura++){            /*que no compare con el 1 */
          if (primero==*pFigura)
             cerrada=1;
    }
    return cerrada;
}

/*----------------------------------------------------------------------*/

int FigBifurc (int *pBifurc){

    int i=0,exito;

    while (*pBifurc){   
          i++;
          pBifurc++;
    }
    if (i>=2)
       exito=1;
    else
        exito=0;                      
    
    return exito;
}


/*----------------------------------------------------------------------*/

char * DetectaFigura(int bifurc,int cerrada){
     char *forma;
     forma=(char *)malloc(8*sizeof(char));

     if (cerrada){
        if (bifurc)
           forma="cilindro";
        else
            forma="circulo";
     }
     else {
          forma="t";
     }
     return forma;
}

/*----------------------------------------------------------------------*/

int ImpResult (char *result){

    FILE *pFicOut;
    char linea[MAXCOLUM];

    sprintf(linea,"Se ha encontrado una figura con forma de %s",result);
    printf("\n\t%s\n",linea);
    printf("\n\tAlmacenamiento de resultados en un fichero\n");

    pFicOut=LeerNomFic("w");

    if (pFicOut){
       fputs(linea,pFicOut);
	   fclose(pFicOut);
	} 
    
    return 0;
}